package org.livee.data.db;

/*
 * Copyright (c) 2007 Hideya Ochiai,  All rights reserved.
 * 
 * Permission of redistribution and use in source and binary forms, 
 * with or without modification, are granted, free of charge, to any person 
 * obtaining the copy of this software under the following conditions:
 * 
 *  1. Any copies of this source code must include the above copyright notice,
 *  this permission notice and the following statement without modification 
 *  except possible additions of other copyright notices. 
 * 
 *  2. Redistributions of the binary code must involve the copy of the above 
 *  copyright notice, this permission notice and the following statement 
 *  in documents and/or materials provided with the distribution.  
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

import java.sql.Connection;
import java.util.Map;


/**
 * @author Hideya Ochiai, The University of Tokyo
 * 
 */
public class CloseCombinedCommand implements IDbCommand {

	/**
	 * Request
	 */
	String m_ID;
	String m_passwd;

	private CloseCombinedCommand() {
	}

	public CloseCombinedCommand(String id, String passwd) {
		m_ID = id;
		if(passwd!=null){
			try {
				m_passwd = org.livee.util.Security.SHA1(passwd);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}else{
			m_passwd=null;
		}
		m_Succeeded = false;
	}

	boolean m_Succeeded;

	public boolean succeeded() {
		return m_Succeeded;
	}

	public String getCommandName() {
		return "CloseCombined";
	}

	public short getImplVersion() {
		return 0x0100;
	}

	public void execCommand(Connection connection, Map conf) throws Exception {

		java.sql.Statement stmt = null;
		String sql = null;
		m_Succeeded = false;
		
		if(m_passwd!=null){
			sql="UPDATE sensor.combined SET working=false WHERE id=\'"+ m_ID + "\' AND passwd=\'"+m_passwd+"\';";
		}else{
			sql="UPDATE sensor.combined SET working=false WHERE id=\'"+ m_ID + "\';";
		}
		try {
			stmt=connection.createStatement();
			if (stmt.executeUpdate(sql) != 0) {
				m_Succeeded = true;
			}
		} catch (Exception e) {
			throw e;
		}finally{
			stmt.close();
		}

	}

}
