package org.livee.data.db;

/*
 * Copyright (c) 2007 Hideya Ochiai,  All rights reserved.
 * 
 * Permission of redistribution and use in source and binary forms, 
 * with or without modification, are granted, free of charge, to any person 
 * obtaining the copy of this software under the following conditions:
 * 
 *  1. Any copies of this source code must include the above copyright notice,
 *  this permission notice and the following statement without modification 
 *  except possible additions of other copyright notices. 
 * 
 *  2. Redistributions of the binary code must involve the copy of the above 
 *  copyright notice, this permission notice and the following statement 
 *  in documents and/or materials provided with the distribution.  
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

import java.sql.Connection;
import java.util.Map;

/**
 * DB_INSERTCommand is obsolete
 * @author Hideya Ochiai, The University of Tokyo
 * @see UploadElementCommand
 */
public class DB_INSERTCommand implements IDbCommand {

	/**
	 * Request
	 */
	String m_ID;
	String m_Time;
	String m_Value;

	private DB_INSERTCommand() {
	}

	protected DB_INSERTCommand(String id, String time, String value) {
		m_ID = id;
		m_Time= time;
		m_Value= value;
		m_Succeeded = false;
	}

	boolean m_Succeeded;

	public boolean succeeded() {
		return m_Succeeded;
	}

	public String getCommandName() {
		return "DB_INSERT";
	}

	public short getImplVersion() {
		return 0x0100;
	}

	public void execCommand(Connection connection, Map conf) throws Exception {

		java.sql.Statement stmt = connection.createStatement();
		
		// If m_ID is working (check at sensor.element) 
		// UPDATE (INSERT INTO) raw.latest, INSERT into raw.daily, raw.archive
		
		stmt.execute("SET TIMEZONE TO DEFAULT;");
		
		String sql = "SELECT id FROM sensor.element WHERE id=\'"+m_ID+"\' AND working=\'t\';";
		
		java.sql.ResultSet rset=stmt.executeQuery(sql);
		if(!rset.next()){
			// The m_ID is not registered.
			rset.close();
			stmt.close();
			return ;
		}
		
		String insert_sql;
		try{
			Double.parseDouble(m_Value);
			sql="UPDATE raw.latest SET time=\'"+m_Time+"\', attrs=\'{}\', value="+m_Value+", sValue=null WHERE id=\'"+m_ID+"\'";
			insert_sql="(id, time, attrs, value, sValue) VALUES (\'"+m_ID+"\',\'"+m_Time+"\',\'{}\',"+m_Value+",null);";
		}
		catch(Exception e){
			sql="UPDATE raw.latest SET time=\'"+m_Time+"\', attrs=\'{}\', value=null, sValue=\'"+m_Value+"\' WHERE id=\'"+m_ID+"\'";
			insert_sql="(id, time, attrs, value, sValue) VALUES (\'"+m_ID+"\',\'"+m_Time+"\',\'{}\',null,\'"+m_Value+"\');";
		}

		try {
			if (stmt.executeUpdate(sql) == 0){
				// "Raw" did not exist ==> INSERT INTO raw.latest
				sql="INSERT INTO raw.latest "+insert_sql;
				stmt.execute(sql);
			}
			
			sql="INSERT INTO aggregation.work "+insert_sql;
			stmt.execute(sql);
			
			sql="INSERT INTO raw.archive "+insert_sql;
			stmt.execute(sql);

			m_Succeeded=true;
		}
		catch(Exception e){
			e.printStackTrace();
		}
		finally{
			stmt.close();
		}

	}
}
