package org.livee.data.db;

/*
 * Copyright (c) 2007 Hideya Ochiai,  All rights reserved.
 * 
 * Permission of redistribution and use in source and binary forms, 
 * with or without modification, are granted, free of charge, to any person 
 * obtaining the copy of this software under the following conditions:
 * 
 *  1. Any copies of this source code must include the above copyright notice,
 *  this permission notice and the following statement without modification 
 *  except possible additions of other copyright notices. 
 * 
 *  2. Redistributions of the binary code must involve the copy of the above 
 *  copyright notice, this permission notice and the following statement 
 *  in documents and/or materials provided with the distribution.  
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

import java.sql.Connection;
import java.util.Map;
import org.livee.data.expr.AbstractData;

/**
 * GetSensorListCommand is obsolete
 * @author Hideya Ochiai, Akihiro Sugiyama, The University of Tokyo
 * @see org.livee.data.command.Authorization
 */
public class GetSensorListCommand implements IDbCommand {

	/**
	 * Request
	 */
	String m_ID;

	/**
	 * Response
	 */

	AbstractData m_Collection = null;

	protected GetSensorListCommand() {
	}

	boolean m_Succeeded;

	public boolean succeeded() {
		return m_Succeeded;
	}

	public AbstractData getResult() {
		return m_Collection;
	}

	public String getCommandName() {
		return "GetSensorList";
	}

	public short getImplVersion() {
		return 0x0100;
	}

	public void execCommand(Connection connection, Map conf) throws Exception {
		
		java.sql.Statement stmt = null;

		try {
			stmt = connection.createStatement();
			String sql = "SELECT id FROM sensor.combined ORDER BY id";
			
			java.sql.ResultSet rset = stmt.executeQuery(sql);

			org.livee.data.expr.DataFactory df = org.livee.data.expr.DataFactory.getInstance();
			m_Collection = df.create("collection");

			while (rset.next()) {
				AbstractData combined=df.create("combined");
				combined.setAttribute("id", rset.getString("id"));

				m_Collection.append(combined);
			} 
			rset.close();
			m_Succeeded = true;
		} catch (Exception e) {
			throw e;
		}
		finally{
			stmt.close();
		}
	}

}
