package org.livee.data.db;
/*
 * Copyright (c) 2007 Hideya Ochiai,  All rights reserved.
 * 
 * Permission of redistribution and use in source and binary forms, 
 * with or without modification, are granted, free of charge, to any person 
 * obtaining the copy of this software under the following conditions:
 * 
 *  1. Any copies of this source code must include the above copyright notice,
 *  this permission notice and the following statement without modification 
 *  except possible additions of other copyright notices. 
 * 
 *  2. Redistributions of the binary code must involve the copy of the above 
 *  copyright notice, this permission notice and the following statement 
 *  in documents and/or materials provided with the distribution.  
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

import org.w3c.dom.*;

import org.livee.data.expr.*;

/**
 * @author Hideya Ochiai, Akihiro Sugiyama, The University of Tokyo
 * 
 */
public class Test {

	public static void main(String[] args) {

		DatabaseAdapter db = DatabaseAdapter.getInstance();
/*
		 CreateSensorCommand command = new CreateSensorCommand("hongo.wide.ad.jp/WM918/elab/","sugi_passwd");
		// UpdatePasswordCommand command = new UpdatePasswordCommand("id2",
		// "sugi", "sugi_passwd");
		// GetProfileCommand command = new GetProfileCommand("2");

		*/
		Document doc = org.livee.util.Xml.parseXmlFile("profile.sample.xml");
		ParserFactory pf = ParserFactory.getInstance();
		AbstractParser combinedParser = pf.get("combined");
		try {
			AbstractData combined = combinedParser.parse(doc
					.getDocumentElement());
			SetProfileCommand command = new SetProfileCommand(combined, "sugi");
			
			try {
				db.postCommand(command);
				System.out.println(command.succeeded());
				
				
			} catch (Exception e) {
				e.printStackTrace();
				
			}
		} catch (Exception e) {
			e.printStackTrace();
		}

		/*
		 * org.livee.data.expr.AbstractData data = command.getResult();
		 * 
		 * org.w3c.dom.Document doc = org.livee.util.Xml.newDocument();
		 * org.w3c.dom.Element el = data.getXml(doc); String str =
		 * org.livee.util.Xml.toString(el); System.out.println(str);
		 */

	}

}
