package org.livee.data.exception;
/*
 * Copyright (c) 2007 Hideya Ochiai,  All rights reserved.
 * 
 * Permission of redistribution and use in source and binary forms, 
 * with or without modification, are granted, free of charge, to any person 
 * obtaining the copy of this software under the following conditions:
 * 
 *  1. Any copies of this source code must include the above copyright notice,
 *  this permission notice and the following statement without modification 
 *  except possible additions of other copyright notices. 
 * 
 *  2. Redistributions of the binary code must involve the copy of the above 
 *  copyright notice, this permission notice and the following statement 
 *  in documents and/or materials provided with the distribution.  
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

import java.util.Collection;
import java.util.Map;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

import org.livee.data.expr.AbstractData;

/**
 * 
 * @author Hideya Ochiai, The University of Tokyo
 */
public class NoServerResolvedLiveEException extends LiveEException {

	AbstractData m_Query;
	String m_Message;
	
	public NoServerResolvedLiveEException(String message){
		m_Message=message;
	}
	
	public NoServerResolvedLiveEException(AbstractData query){
		m_Query=query;
	}
	
	public String getAttribute(String name) {
		if(name!=null && name.equals("type")){
			return "noServerResolved";
		}
		return null;
	}

	public Map getAttributes() {
		Map map=new java.util.Hashtable();
		map.put("type", "noServerResolved");
		return map;
	}

	public Collection getChildren() {
		return null;
	}

	public String getDataType() {
		return "NoServerResolvedLiveEException";
	}

	public String getTextContent() {
		return null;
	}

	public Element getXml(Document doc) {
		String ns="http://live-e.org/Error/2007/03/";
		Element err=doc.createElementNS(ns, "error");
		err.setAttribute("type", "noServerResolved");
		
		if(m_Query!=null){
			err.appendChild(m_Query.getXml(doc));
		}
		if(m_Message!=null){
			err.setTextContent(m_Message);
		}
		
		return err;
	}
}
