package org.livee.data.replicate;
/*
 * Copyright (c) 2007 Hideya Ochiai,  All rights reserved.
 * 
 * Permission of redistribution and use in source and binary forms, 
 * with or without modification, are granted, free of charge, to any person 
 * obtaining the copy of this software under the following conditions:
 * 
 *  1. Any copies of this source code must include the above copyright notice,
 *  this permission notice and the following statement without modification 
 *  except possible additions of other copyright notices. 
 * 
 *  2. Redistributions of the binary code must involve the copy of the above 
 *  copyright notice, this permission notice and the following statement 
 *  in documents and/or materials provided with the distribution.  
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

import java.util.Collection;
import java.util.Map;

import org.livee.data.expr.AbstractData;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

/**
 * 
 * @author Hideya Ochiai, The University of Tokyo
 */
public class ProfileCombinedReplicationData implements AbstractData {

	String m_ID;
	String m_Created;
	String m_Expired;
	String m_Latitude;
	String m_Longitude;
	String m_Attrs;
	
	protected ProfileCombinedReplicationData(){
		m_ID=null;
		m_Created=null;
		m_Expired=null;
		m_Latitude=null;
		m_Longitude=null;
		m_Attrs=null;
	}
	
	public void append(AbstractData child) {}

	public String getAttribute(String name) {
		if(name==null){
			return null;
		}
		if(name.equals("id")){
			return m_ID;
		}else if(name.equals("created")){
			return m_Created;
		}else if(name.equals("expired")){
			return m_Expired;
		}else if(name.equals("latitude")){
			return m_Latitude;
		}else if(name.equals("longitude")){
			return m_Longitude;
		}else if(name.equals("attrs")){
			return m_Attrs;
		}
		return null;
	}

	public Map getAttributes() {
		Map attrs=new java.util.Hashtable();

		if(m_ID!=null){
			attrs.put("id",m_ID);
		}
		if(m_Created!=null){
			attrs.put("created",m_Created);
		}
		if(m_Expired!=null){
			attrs.put("expired",m_Expired);
		}
		if(m_Latitude!=null){
			attrs.put("latitude",m_Latitude);
		}
		if(m_Longitude!=null){
			attrs.put("longitude",m_Longitude);
		}
		if(m_Attrs!=null){
			attrs.put("attrs",m_Attrs);
		}
		return attrs;
	}

	public Collection getChildren() {
		return null;
	}

	public String getDataType() {
		return "ProfileCombinedReplication";
	}

	public String getTextContent() {
		return null;
	}

	public void remove(AbstractData child) {}

	public void removeAttribute(String name) {
		if(name==null){
			return ;
		}
		if(name.equals("id")){
			m_ID=null;
		}else if(name.equals("created")){
			m_Created=null;
		}else if(name.equals("expired")){
			m_Expired=null;
		}else if(name.equals("latitude")){
			m_Latitude=null;
		}else if(name.equals("longitude")){
			m_Longitude=null;
		}else if(name.equals("attrs")){
			m_Attrs=null;
		}
	}

	public void setAttribute(String name, String value) {
		
		if(name==null){
			return ;
		}
		if(name.equals("id")){
			m_ID=value;
		}else if(name.equals("created")){
			m_Created=value;
		}else if(name.equals("expired")){
			m_Expired=value;
		}else if(name.equals("latitude")){
			m_Latitude=value;
		}else if(name.equals("longitude")){
			m_Longitude=value;
		}else if(name.equals("attrs")){
			m_Attrs=value;
		}
	}

	public void setTextContent(String text) {}

	public Element getXml(Document doc) {
		String ns="http://live-e.org/DataManager/2007/03/";
		Element val=doc.createElementNS(ns, "profileCombined");
		if(m_ID!=null){
			val.setAttribute("id",m_ID);
		}
		if(m_Created!=null){
			val.setAttribute("created", m_Created);
		}
		if(m_Expired!=null){
			val.setAttribute("expired", m_Expired);
		}
		if(m_Latitude!=null){
			val.setAttribute("latitude", m_Latitude);
		}
		if(m_Longitude!=null){
			val.setAttribute("longitude", m_Longitude);
		}
		if(m_Attrs!=null){
			val.setAttribute("attrs", m_Attrs);
		}
		return val;
	}

}
