package org.livee.data.replicate;
/*
 * Copyright (c) 2007 Hideya Ochiai,  All rights reserved.
 * 
 * Permission of redistribution and use in source and binary forms, 
 * with or without modification, are granted, free of charge, to any person 
 * obtaining the copy of this software under the following conditions:
 * 
 *  1. Any copies of this source code must include the above copyright notice,
 *  this permission notice and the following statement without modification 
 *  except possible additions of other copyright notices. 
 * 
 *  2. Redistributions of the binary code must involve the copy of the above 
 *  copyright notice, this permission notice and the following statement 
 *  in documents and/or materials provided with the distribution.  
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

import org.livee.data.expr.AbstractData;
import org.livee.data.expr.AbstractParser;
import org.w3c.dom.Element;

/**
 * 
 * @author Hideya Ochiai, The University of Tokyo
 */
public class RawArchiveReplicationParser implements AbstractParser {

	public String getParserName() {
		return "RawArchiveReplication";
	}

	public AbstractData parse(Element xml) throws Exception {
		if(xml.getNamespaceURI().equals("http://live-e.org/DataManager/2007/03/")){
			// For Version 200703			
			if(xml.getTagName().equals("rawArchive")){
				
				AbstractData rawArchive=DataFactory.getInstance().create("replicateRawArchive");

				String id=xml.getAttribute("id");
				String time=xml.getAttribute("time");
				String attrs=xml.getAttribute("attrs");
				String value=xml.getAttribute("value");
				String sValue=xml.getAttribute("sValue");

				if(id!=null && !id.equals("")){
					rawArchive.setAttribute("id", id);
				}
				if(time!=null && !time.equals("")){
					rawArchive.setAttribute("time", time);
				}
				if(attrs!=null && !attrs.equals("")){
					rawArchive.setAttribute("attrs", attrs);
				}
				if(value!=null && !value.equals("")){
					rawArchive.setAttribute("value", value);
				}
				if(sValue!=null && !sValue.equals("")){
					rawArchive.setAttribute("sValue", sValue);
				}
				
				return rawArchive;
			}else{
				// Syntax Error
				return null;
			}
		}
		
		return null;
	}

}
