package org.livee.data.replicate;
/*
 * Copyright (c) 2007 Hideya Ochiai,  All rights reserved.
 * 
 * Permission of redistribution and use in source and binary forms, 
 * with or without modification, are granted, free of charge, to any person 
 * obtaining the copy of this software under the following conditions:
 * 
 *  1. Any copies of this source code must include the above copyright notice,
 *  this permission notice and the following statement without modification 
 *  except possible additions of other copyright notices. 
 * 
 *  2. Redistributions of the binary code must involve the copy of the above 
 *  copyright notice, this permission notice and the following statement 
 *  in documents and/or materials provided with the distribution.  
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

import org.livee.util.Xml;
import org.livee.data.expr.AbstractData;
import org.livee.data.expr.AbstractParser;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

/**
 * 
 * @author Hideya Ochiai, The University of Tokyo
 */
public class TestReplicate {

	public static void main(String[] args) throws Exception {
			
		testRestore();
		
		if(1<2){
			return ;
		}
		
		
		org.livee.data.db.DatabaseAdapter db=org.livee.data.db.DatabaseAdapter.getInstance();
		
//		DumpProfileCommand command=new DumpProfileCommand("2007-04-25 00:00:00","2007-08-26 00:00:00");
//		db.postCommand(command);
//		AbstractData data=command.getDataManagerReplication();
		
		DumpArchiveDataCommand command=new DumpArchiveDataCommand("2007-04-25 00:00:00","2007-08-26 00:00:00");
		db.postCommand(command);
		AbstractData data=command.getDataManagerReplication();

//		DumpLatestDataCommand command=new DumpLatestDataCommand();
//		db.postCommand(command);
//		AbstractData data=command.getDataManagerReplication();

		//ReplicateRawLatestCollectionCommand command=new ReplicateRawLatestCollectionCommand();
		//db.postCommand(command);
		//AbstractData data=command.getRawLatestCol();
		
		//GetReplicateRawArchiveCollectionCommand command=new GetReplicateRawArchiveCollectionCommand("2007-04-25 00:00:00","2007-04-27 00:00:00");
		//db.postCommand(command);
		//AbstractData data=command.getRawArchiveCol();

		//ReplicateSensorCombinedCollectionCommand command=new ReplicateSensorCombinedCollectionCommand();
		//db.postCommand(command);
		//AbstractData data=command.getSensorCombinedCol();
		
		//ReplicateSensorElementCollectionCommand command=new ReplicateSensorElementCollectionCommand();
		//db.postCommand(command);
		//AbstractData data=command.getSensorElementCol();
		
		//ReplicateProfileCombinedArchiveCommand command=new ReplicateProfileCombinedArchiveCommand("2007-04-25 00:00:00","2007-04-26 00:00:00");
		//db.postCommand(command);
		//AbstractData data=command.getProfileCombinedArchive();
		
		//ReplicateProfileElementArchiveCommand command=new ReplicateProfileElementArchiveCommand("2007-04-25 00:00:00","2007-04-26 00:00:00");
		//db.postCommand(command);
		//AbstractData data=command.getProfileElementArchive();
		
		Document doc=Xml.newDocument();
		System.out.println(Xml.toString(data.getXml(doc)));
	}
	
	public static void testRestore() throws Exception {
		
		Document doc=Xml.parseXmlFile("test/dataManagerReplication.xml");
		Element xml=doc.getDocumentElement();
		
		AbstractParser parser=org.livee.data.replicate.ParserFactory.getInstance().get("replicateDataManager");
		AbstractData dataManager=parser.parse(xml);

		org.livee.data.db.DatabaseAdapter db=org.livee.data.db.DatabaseAdapter.getInstance();
		
		//RestoreProfileCommand command=new RestoreProfileCommand(dataManager);
		RestoreLatestDataCommand command=new RestoreLatestDataCommand(dataManager);
		db.postCommand(command);
		
		if(command.succeeded()){
			System.out.println("Restore succeeded...");
		}

	}
	
	public static void testExpr() throws Exception {
		Document doc=Xml.parseXmlFile("test/dataManagerReplication.xml");
		Element xml=doc.getDocumentElement();
		
		AbstractParser parser=org.livee.data.replicate.ParserFactory.getInstance().get("replicateDataManager");
		AbstractData dataManager=parser.parse(xml);
	
		System.out.println(Xml.toString(dataManager.getXml(doc)));
		
	}

}
