package org.livee.data.srv;
/*
 * Copyright (c) 2007 Hideya Ochiai,  All rights reserved.
 * 
 * Permission of redistribution and use in source and binary forms, 
 * with or without modification, are granted, free of charge, to any person 
 * obtaining the copy of this software under the following conditions:
 * 
 *  1. Any copies of this source code must include the above copyright notice,
 *  this permission notice and the following statement without modification 
 *  except possible additions of other copyright notices. 
 * 
 *  2. Redistributions of the binary code must involve the copy of the above 
 *  copyright notice, this permission notice and the following statement 
 *  in documents and/or materials provided with the distribution.  
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

import org.livee.data.db.DatabaseAdapter;
import org.livee.data.db.CommandFactory;
import org.livee.data.db.DB_INSERTCommand;

import org.w3c.dom.Element;
import org.w3c.dom.Node;


/**
 * DB_INSERT is obsolete 
 * @author Hideya Ochiai, The University of Tokyo
 * @see DataUpload200703
 */
public class DB_INSERT {

	// Do Nothing in FUTURE IMPLEMENTATION
	public String init(String line){
		return "<OK />";
	}
	
	public String update(String line){
		
		String ret_string="<OK />";
		try{
			org.w3c.dom.Document doc=org.livee.util.Xml.parseXml(line);
			org.w3c.dom.Element root=doc.getDocumentElement();
			
			String m_ID=null;
			String m_Time=null;
			String m_Value=null;
			
			Node node=root.getFirstChild();		
			while(node!=null){
				if(node.getNodeType()==Node.ELEMENT_NODE){
					Element e=(Element)node;
					String tagName=e.getTagName();
					if(tagName.equals("Time")){
						String t=e.getTextContent();
						m_Time=org.livee.util.W3CTimestamp.parseToDateString(t);
					}else if(tagName.equals("ID")){
						
						Node node2=e.getFirstChild();
						while(node2!=null){
							if(node2.getNodeType()==Node.ELEMENT_NODE){
								Element e2=(Element)node2;
								if(e2.getTagName().equals("Live-EID")){
									m_ID=e2.getTextContent();
								}
							}
							node2=node2.getNextSibling();
						}
						
					}else if(tagName.equals("Value")){
						m_Value=e.getTextContent();
					}
				}
				node=node.getNextSibling();
			}		

			if(m_ID!=null && m_Time!=null && m_Value!=null){
				
				DB_INSERTCommand command=CommandFactory.createDB_INSERTCommand(m_ID, m_Time, m_Value);
				
				DatabaseAdapter db=DatabaseAdapter.getInstance();
				db.postCommand(command);
				
				if(!command.succeeded()){
					ret_string="<error type=\'unknown\'/>";
				}
			}
		}
		catch(Exception e){
			ret_string="<error type=\'"+e.getMessage()+"\' />";
		}
		return ret_string;
	}
}
