package org.livee.data.srv;
/*
 * Copyright (c) 2007 Hideya Ochiai,  All rights reserved.
 * 
 * Permission of redistribution and use in source and binary forms, 
 * with or without modification, are granted, free of charge, to any person 
 * obtaining the copy of this software under the following conditions:
 * 
 *  1. Any copies of this source code must include the above copyright notice,
 *  this permission notice and the following statement without modification 
 *  except possible additions of other copyright notices. 
 * 
 *  2. Redistributions of the binary code must involve the copy of the above 
 *  copyright notice, this permission notice and the following statement 
 *  in documents and/or materials provided with the distribution.  
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

import org.livee.util.Base64Coder;
import org.livee.data.expr.*;
import org.livee.util.Xml;

/**
 * 
 * @author Hideya Ochiai, The University of Tokyo
 */
public class TestSrv {

	public static void main(String[] args) {
		
		Admin200703 admin=new Admin200703();
		admin.queryService("DataManagerReplicatio200703");
		
		/*
		
		//test();
		GlobalDataProvider200703 p=new GlobalDataProvider200703();
		//DataProvider200703 p=new DataProvider200703();
		//String latestData=p.getLatestDataAll("JST", "Thailand");
		
		//System.out.println(latestData);
		
		String data=p.getLatestData("live-e.org/Virtual/01000001/", "JST", "Japanese");
		//String data=p.getDataDailyAggregated("hongo.wide.ad.jp/WM918/elab2/", "2007-07-03T00:00:00.0000000+09:00", "2007-07-05T00:00:00.0000000+09:00", "JST", "Japanese");
		System.out.println(data);
		
		//testDataLoad();
		//testAdminQuery();
		 * 
		 * 
		 */
	}
	
	public static void testAdminQuery(){
		
		String query="<query domain=\"admin\" name=\"*\" xmlns=\"http://live-e.org/Query/2007/03/\" />";
		
		Admin200703 admin=new Admin200703();
		
		String response=admin.search(query);
		System.out.println();
		
	}
	
	public static void testDataLoad(){
		DataProvider200703 dp=new DataProvider200703();
		
		try{
			java.io.BufferedWriter writer=new java.io.BufferedWriter(new java.io.FileWriter("test.xml"));
			writer.write(dp.getLatestDataAll("JST", "Japanese"));
			writer.close();
		}
		catch(Exception e){}
	}
	
	public static void test(){
		Admin200703 admin=new Admin200703();
		System.out.println(admin.replicate());
		
		//adminTest();
		
		//uploadTest();
		
		//java.util.Calendar cal=org.livee.util.W3CTimestamp.parse("2007-12-23T24:12:42.0000000+12:30");
		
		//System.out.println(cal.get(java.util.Calendar.ZONE_OFFSET));
		
		//System.out.println(org.livee.util.W3CTimestamp.toString(cal));
		
		
		//profileManagementTest();
		//testProfileSchema2();
	}
	
	
	public static void uploadTest(){
		
		
		String combined="<sensorGroup class=\"combinedSensor\" id=\"hongo.wide.ad.jp/WM918/elab/\" authorization=\"MDAwMDAwMDA=\">" +
		"<sensor id=\"hongo.wide.ad.jp/WM918/elab/Temperature\">" +
		"<value time=\"2007-08-02T00:00:00.0000000+09:00\">25.5</value>" +
		"<value time=\"2007-08-02T01:00:00.0000000+09:00\">25.6</value>" +
		"<value time=\"2007-08-02T02:00:00.0000000+09:00\">25.7</value>" +
		"<value time=\"2007-08-02T03:00:00.0000000+09:00\">ERROR</value>" +
		"<value time=\"2007-08-02T04:00:00.0000000+09:00\">35.5</value>" +
		"</sensor>"+
	//	"<sensor id=\"hongo.wide.ad.jp/WM918/elab/Humidity\">" +
	//	"<value time=\"2007-08-02T00:00:00.0000000+09:00\">35.5</value>" +
	//	"<value time=\"2007-08-02T01:00:00.0000000+09:00\">45.6</value>" +
	//	"<value time=\"2007-08-02T02:00:00.0000000+09:00\">55.7</value>" +
	//	"<value time=\"2007-08-02T03:00:00.0000000+09:00\">ERROR</value>" +
	//	"<value time=\"2007-08-02T04:00:00.0000000+09:00\">65.5</value>" +
	//	"</sensor>"+
		"<sensor id=\"hongo.wide.ad.jp/WM918/elab/Pressure\">" +
		"<value time=\"2007-08-02T00:00:00.0000000+09:00\">1025.5</value>" +
		"<value time=\"2007-08-02T01:00:00.0000000+09:00\">1025.6</value>" +
		"<value time=\"2007-08-02T02:00:00.0000000+09:00\">1025.7</value>" +
		"<value time=\"2007-08-02T03:00:00.0000000+09:00\">ERROR</value>" +
		"<value time=\"2007-08-02T04:00:00.0000000+09:00\">1035.5</value>" +
		"</sensor>"+
				"</sensorGroup>";
		
		String collection="<sensorGroup class=\"collection\" xmlns=\"http://live-e.org/DataType/2007/03/\">"+combined+"</sensorGroup>";
		
		DataUpload200703 uploader=new DataUpload200703();
		
		System.out.println(uploader.uploadCollection(collection));
		
	}
	
	public static void testProfileSchema2(){
		org.livee.data.tools.ProfileSchemaProcessor p=org.livee.data.tools.ProfileSchemaProcessor.getInstance();
		
		try{
			System.out.println(p.validateAttribute("location", "hello world!!"));
		}
		catch(Exception e){
			System.err.println(e.getMessage());
		}
	}
	
	public static void testProfileSchema(){
		org.w3c.dom.Document doc=org.livee.util.Xml.parseXmlFile("profile_schema.xml");
		org.w3c.dom.Element root=doc.getDocumentElement();
		
		ParserFactory pf=ParserFactory.getInstance();
		AbstractParser profile_parser=pf.get("profileSchema");
		
		try{
			AbstractData profileSchema=profile_parser.parse(root);
			
			java.util.Iterator itr=profileSchema.getChildren().iterator();
			while(itr.hasNext()){
				AbstractData schema=(AbstractData)itr.next();
				System.out.println(schema.getAttribute("name")+":"+schema.getAttribute("type")+":"+schema.getAttribute("value"));
			}
		}
		
		catch(Exception e){
			e.printStackTrace();
		}
		
	}
	
	public static void DB_INSERTTest(){
		
		String xml="<Data><Time>2007-04-24T19:30:00.000000+09:00</Time><ID><Live-EID>hongo.wide.ad.jp/WM918/elab/Temperature</Live-EID></ID><Value>39.4</Value></Data>";
		DB_INSERT db_insert=new DB_INSERT();
		db_insert.update(xml);
	}
	
	public static void profileManagementTest(){
		System.out.println(Base64Coder.encodeString("00000000"));
		String str="<sensorGroup class=\"combinedSensor\" id=\"hongo.wide.ad.jp/WM918/elab/\" authorization=\"MDAwMDAwMDA=\" latitude=\"35.3\" longitude=\"135.5\" organization_jp=\"Japanese\" organization_en=\"English\" xmlns=\"http://live-e.org/DataType/2007/03/\" ><sensor id=\"hongo.wide.ad.jp/WM918/elab/Temperature\" sensorType=\"Temperature\" /><sensor id=\"hongo.wide.ad.jp/WM918/elab/Pressure\" sensorType=\"Pressure\" /></sensorGroup>";
		
	//	DataProvider200703 provider=new DataProvider200703();
				
	//	System.out.println(provider.getAvailableTimeZones());
		
	//	System.out.println(provider.getAvailableLocales());
		
	//	System.out.println(provider.getLatestData("1","Africa/Tunis", "English"));
		
	//	System.out.println(provider.getLatestDataByAreaRect(90,0,150,120,"Africa/Tunis", "English"));
		
		//System.out.println(provider.getArchiveCombinedData("1", "2007-03-01T00:00:00.0000000+09:00", "2007-03-02T00:00:00.0000000+09:00", "JST", "English"));
		
		ProfileManagement200703 management = new ProfileManagement200703();
		//System.out.println(management.updatePassword("test", "#$%ryj&$%",org.livee.util.Base64Coder.encodeString("sugi2")));
		//System.out.println(management.getProfile("hongo.wide.ad.jp/WM918/elab/"));
		System.out.println(management.getProfileSchema());
	}

}
